config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  root 'photos#index'

  ActiveAdmin.routes(self)
  devise_for :users

  get 'photos/new' => 'photos#new'
  post 'photos/new' => 'photos#create'

  get 'photos/:photo_id/likes/new', to: 'likes#new', as: 'likes_new'
  get 'likes/:id/destroy', to: 'likes#destroy', as: 'likes_destroy'

  post 'photos/:photo_id/comments/new', to: 'comments#create', as: 'comments_new'

  get 'users/:followed_id/relationships/new', to: 'relationships#new',  as: 'relationships_new'
  get 'relationships/:id/destroy', to: 'relationships#destroy', as: 'relationships_destroy'

  get 'users/:id', to: 'users#show', as: 'users_show'
end

app/models/adapters/only_admins.rb
# frozen_string_literal: true

class Adapters::OnlyAdmins < ActiveAdmin::AuthorizationAdapter
  def authorized?(_action, _subject = nil)
    user.is_admin?
  end
  end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :user
  belongs_to :photo
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :user
  belongs_to :photo
end

app/models/photo.rb
# frozen_string_literal: true

class Photo < ApplicationRecord
  has_many_attached :images

  belongs_to :user
  has_many :likes
  has_many :comments

  def get_like_for_user(user_id)
    likes.each do |like|
      return like if (like.user_id == user_id) && (like.photo_id == id)
    end
    nil
  end
end

app/models/relationship.rb
class Relationship < ApplicationRecord
	belongs_to :follower, class_name: "User"
  belongs_to :followed, class_name: "User"
end

app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  validates :name, presence: true, length: { maximum: 50 }
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_many :photos, dependent: :destroy
  has_many :active_relationships, class_name: 'Relationship',
                                  foreign_key: 'follower_id',
                                  dependent: :destroy

  has_many :likes
  has_many :comments

  def get_relationship_by_followed(followed_id)
    active_relationships.each do |relationship|
      return relationship if relationship.followed_id == followed_id
    end

    nil
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  before_action :configure_permitted_parameters, if: :devise_controller?

  def access_denied(exception)
    flash[:danger] = exception.message
    redirect_to root_url
  end

  private

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name])
    devise_parameter_sanitizer.permit(:account_update, keys: [:name])
  end
end

app/controllers/comments_controller.rb
# frozen_string_literal: true

class CommentsController < ApplicationController
  def new
    comment = Comment.new
  end

  def create
    comment = Comment.new(comment_params)
    comment.user = current_user
    comment.photo_id = params[:photo_id]

    if comment.save
      redirect_back(fallback_location: root_path)
    else
      redirect_to comments_new_path
    end
  end

  def comment_params
    params.require(:comment).permit(:text)
  end
  end

app/controllers/likes_controller.rb
# frozen_string_literal: true

class LikesController < ApplicationController
  def new
    like = Like.new

    like.user_id = current_user.id
    like.photo_id = params[:photo_id]

    like.save
    redirect_back(fallback_location: root_path)
  end

  def destroy
    like = Like.find(params[:id])
    like.destroy

    redirect_back(fallback_location: root_path)
  end
  end

app/controllers/photos_controller.rb
# frozen_string_literal: true

class PhotosController < ApplicationController
  def index
    @photos = Photo.all.order('photos.created_at DESC')
  end

  def new
    @photo = Photo.new
  end

  def create
    photo = Photo.new(photo_params)
    photo.user = current_user
    if photo.save!
      redirect_to root_path
    else
      redirect_to photos_new_path
    end
  end

  private

  def photo_params
    params.require(:photo).permit(images: [])
  end
end

app/controllers/relationships_controller.rb
# frozen_string_literal: true

class RelationshipsController < ApplicationController
  def new
    relationship = Relationship.new

    relationship.follower_id = current_user.id
    relationship.followed_id = params[:followed_id]

    relationship.save
    redirect_to users_show_path(params[:followed_id])
  end

  def destroy
    relationship = Relationship.find(params[:id])
    relationship.destroy

    redirect_to users_show_path(relationship.followed_id)
  end
end

app/controllers/users_controller.rb
# frozen_string_literal: true

class UsersController < ApplicationController
  def show
    @user = User.find(params[:id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/likes_helper.rb
module LikesHelper
end

app/helpers/relationships_helper.rb
module RelationshipsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Instagram-copy</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
    <%= csrf_meta_tags %>
  </head>
  <body>
    <%= render 'layouts/application/navbar' %>
    <div id="content" class="container">
      <%= yield %>
    </div>
  </body>
</html>

app/views/layouts/application/_navbar.html.erb
<nav class="navbar fixed-top navbar-dark bg-dark navbar-expand-md">
    <div class="container">
        <button type="button" class="navbar-toggler collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
          <span class="sr-only">Toggle navigation</span>
          &#x2630;
        </button>

        <span class="navbar-brand">Instagram</span>

        <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
            <ul class="nav navbar-nav">
                <li class="nav-item"><a href="/" class="nav-link">Лента</a>
                </li>
                <% if current_user %>
                <li class="nav-item"><%= link_to 'Мой профиль', users_show_path(current_user.id), class: 'nav-link' %>
                </li>
                <% end %>
            </ul>
            <div class="navbar-nav ml-auto">
              <% if user_signed_in? %>

              <div class="nav-item">
                <span class="navbar-text">
                  Hello,&nbsp;
                <span>
              </div>

              <div class="dropdown show">
                <%= link_to current_user.name, edit_user_registration_path(current_user), class: 'btn btn-secondary dropdown-toggle', 'role' => "button", 'id' => "dropdownMenuLink", 'data-toggle' => "dropdown", 'aria-haspopup' => "true", 'aria-expanded' => "false" %>
                <div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
                  <%= link_to 'Edit profile', edit_user_registration_path(current_user), class: 'dropdown-item' %>
                  <%= link_to 'Sign out', destroy_user_session_path, method: :delete, class: 'dropdown-item' %>
                </div>
              <div>

              <% else %>
                  <div class="nav-item">
                     <%= link_to 'Sign up', new_user_registration_path, class: 'nav-link' %>
                  </div>
                  <div class="nav-item">
                     <%= link_to 'Log in', new_user_session_path, class: 'nav-link' %>
                  </div>
              <% end %>
            </div>
        </div>
    </div>
</nav>

app/views/photos/index.html.erb
<%= render :partial => 'shared/photos', :locals => { :photos => @photos } %>

<%= link_to '+', photos_new_path, class: 'btn-add-photo'%>

app/views/photos/new.html.erb
<%= form_for "photo" do |form| %>
    <%= form.label :images %>
    <%= form.file_field :images, multiple: true %> <br/>
    <%= form.submit "Добавить" %>
<% end %>

app/views/shared/_photos.html.erb
<div class="row">
  <% photos.where('is_hidden = ?', false).each do |photo| %>
    <div class="col-4<%= ' offset-4' if !defined?(in_cols) %>">
      <div class="card my-2">
        <div class="card-header">
          <%= link_to photo.user.name, users_show_path(photo.user.id) %>
        </div>

        <div class="card-body">
          <% if photo.images.length === 1 %>
            <img class="photo w-100" src="<%= url_for(photo.images[0]) %>">
          <% else %>
            <div id="photo-<%= photo.id %>" class="carousel slide" data-ride="carousel">
              <div class="carousel-inner" role="listbox">
                <% photo.images.each_with_index do |image, i| %>
                  <div class="carousel-item<%= ' active' if i == 0 %>">
                    <img class="photo d-block w-100" src="<%= url_for(image) %>">
                  </div>
                <% end %>
              </div>

              <a class="carousel-control-prev" href="#photo-<%= photo.id %>" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
              </a>

              <a class="carousel-control-next" href="#photo-<%= photo.id %>" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
              </a>
            </div>
          <% end %>

          <div class="stats">
            <span class="badge badge-danger">Likes: <%= photo.likes.count %></span>
            <span class="badge badge-info">Comments: <%= photo.comments.count %></span>
          </div>
          <hr />
          <% if current_user %>
            <div class="like">
              <% like = photo.get_like_for_user(current_user.id)%>
              <%  if like  %>
                  <%= link_to "💔", likes_destroy_path(like.id), :class => "btn-like" %>
              <%  else %>
                  <%= link_to "❤️", likes_new_path(photo.id), :class => "btn-like" %>
              <%  end %>
            </div>
            
            <div class="comments mt-3">
              <% photo.comments.where('is_hidden = ?', false).each do |comment| %>
                <div class="alert alert-secondary" role="alert">
                  <span class="text-primary"><%= comment.user.name %>:</span><br/><%= comment.text %>
                </div>
              <% end %>
            </div>
            <%= form_for "comment", url: comments_new_path(photo.id), :html => {:class => 'comment-form'} do |form| %>
              <%= form.text_area :text %>
              <%= form.submit "Опубликовать", :class => "btn btn-primary btn-sm" %>
            <% end %>
          <%  end %>
        </div>

        <div class="card-footer text-muted">
          <%= photo.created_at %>
        </div>
      </div>
    </div>
  <% end %>

  <% if photos.length == 0 %>
    <div class="col-12">
      <h3 class="text-warning">Нет фотографий</h3>
    </div>
  <% end %>
</div>

app/views/users/show.html.erb
<h2><%= @user.name %></h2>
<% if current_user && current_user.id != @user.id %>
    <% relationship = current_user.get_relationship_by_followed(@user.id) %>
    <% if relationship %>
        <%= link_to "Отписаться", relationships_destroy_path(relationship.id), class: 'btn btn-primary text-white' %>
    <% else %>
        <%= link_to "Подписаться", relationships_new_path(@user.id), class: 'btn btn-primary text-white' %>
    <% end %>
<% end %>
<%= render :partial => 'shared/photos', :locals => { :photos => @user.photos.order('photos.created_at DESC'), :in_cols => true } %>

<% if current_user.id  == @user.id %>
    <%= link_to '+', photos_new_path, class: 'btn-add-photo'%>
<% end %>